nx_server_plugin_sdk 1.0 Server Plugin SDK

Public Member Functions | List of all members
nx::vms_server_plugins::analytics::test::UtilityProvider Class Reference
Inheritance diagram for nx::vms_server_plugins::analytics::test::UtilityProvider:

## Public Member Functions
virtual int64_t | vmsSystemTimeSinceEpochMs () const override
virtual const nx::sdk::IString * | getHomeDir () const override
virtual const char * | serverId () const override
virtual IString * | cloudSystemId () const
virtual IString * | cloudAuthKey () const override
virtual IString * | supportedVectorizationModels () const override
virtual IString * | getDataDir () const override
virtual const char * | cloudToken () const override
virtual void | subscribeForCloudTokenUpdate (ICloudTokenSubscriber *) override
virtual void | setServiceUsageQuantities (const char *, const nx::sdk::IStringMap *) override
virtual void | doSendHttpRequest (HttpDomainName requestDomain, const char *url, const char *httpMethod, const char *mimeType, const char *requestBody, IHttpRequestCompletionHandler *callback) const override
virtual const nx::sdk::IString * | getServerSdkVersion () const override
Public Member Functions inherited from nx::sdk::RefCountable< IUtilityProvider >
| RefCountable (const RefCountable &)=delete
| RefCountable (RefCountable &&)=delete
RefCountable & | operator= (const RefCountable &)=delete
RefCountable & | operator= (RefCountable &&)=delete
virtual int | addRef () const override
virtual int | releaseRef () const override
int | refCount () const
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider, IUtilityProvider7 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IUtilityProvider7
std::string | dataDir () const
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider7, IUtilityProvider6 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider6, IUtilityProvider5 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider5, IUtilityProvider4 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IUtilityProvider4
void | sendHttpRequest (HttpDomainName requestDomainName, const char *url, const char *httpMethod, const char *mimeType, const char *requestBody, Ptr< IHttpRequestCompletionHandler > callback) const
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider4, IUtilityProvider3 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider3, IUtilityProvider2 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider2, IUtilityProvider1 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IUtilityProvider1
std::string | serverSdkVersion () const
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider1, IUtilityProvider0 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IUtilityProvider0
std::string | homeDir () const
Public Member Functions inherited from nx::sdk::Interface< IUtilityProvider0 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IRefCountable
virtual | ~IRefCountable ()=default
template<class Interface >
Ptr< Interface > | queryInterface ()
template<class Interface >
Ptr< const Interface > | queryInterface () const
int | refCountThreadUnsafe () const

## Additional Inherited Members
Public Types inherited from nx::sdk::IUtilityProvider4
enum | HttpDomainName : int { cloud, vms }
using | IHttpRequestCompletionHandler0 = IHttpRequestCompletionHandler
Static Public Member Functions inherited from nx::sdk::IUtilityProvider
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IUtilityProvider7
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IUtilityProvider6
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IUtilityProvider5
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IUtilityProvider4
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IUtilityProvider3
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IUtilityProvider2
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IUtilityProvider1
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IUtilityProvider0
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IRefCountable
static auto | interfaceId ()
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider, IUtilityProvider7 >
virtual IRefCountable * | queryInterface (const IRefCountable::InterfaceId *id) override
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider7, IUtilityProvider6 >
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider6, IUtilityProvider5 >
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider5, IUtilityProvider4 >
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider4, IUtilityProvider3 >
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider3, IUtilityProvider2 >
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider2, IUtilityProvider1 >
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider1, IUtilityProvider0 >
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Protected Member Functions inherited from nx::sdk::Interface< IUtilityProvider0 >
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Static Protected Member Functions inherited from nx::sdk::IRefCountable
template<int len>
static const InterfaceId * | makeId (const char(&charArray)[len])
template<int len, int alternativeLen>
static std::vector< const InterfaceId * > | makeIdWithAlternative (const char(&charArray)[len], const char(&alternativeCharArray)[alternativeLen])
template<class TemplateInstance , class TemplateArg , int len>
static const InterfaceId * | makeIdForTemplate (const char(&baseIdCharArray)[len])
static std::vector< const InterfaceId * > | alternativeInterfaceIds (const InterfaceId *id)
static std::vector< const InterfaceId * > | alternativeInterfaceIds (std::vector< const InterfaceId *> ids)

## Member Function Documentation

## ◆ cloudToken()

virtual const char* nx::vms_server_plugins::analytics::test::UtilityProvider::cloudToken | ( |  | ) | const
| inline override virtual

The source of cloud token is the response to the request authenticated by system credentials (cloudSysId + authKey) to the https://<cloud-host>/oauth2/v1/token Token is retrieved asynchronously by the VMS server. It means that the moment when this function starts returning a valid token is not specified. Plugin must also subscribe to token update notification using `subscribeForCloudTokenUpdate()` if it wants to use current cloud token. Always returns a valid string. If the token is not available, this string will be empty but still valid ("").

Implements nx::sdk::IUtilityProvider5.

## ◆ doSendHttpRequest()

virtual void nx::vms_server_plugins::analytics::test::UtilityProvider::doSendHttpRequest | ( | HttpDomainName | requestDomainName,
|  | const char * | url,
|  | const char * | httpMethod,
|  | const char * | mimeType,
|  | const char * | requestBody,
|  | IHttpRequestCompletionHandler * | callback
| ) |  | const
| inline override virtual

Called by sendHttpRequest()

Implements nx::sdk::IUtilityProvider4.

## ◆ getDataDir()

virtual IString* nx::vms_server_plugins::analytics::test::UtilityProvider::getDataDir | ( |  | ) | const
| inline override virtual

Called by dataDir

Implements nx::sdk::IUtilityProvider7.

## ◆ getHomeDir()

virtual const nx::sdk::IString* nx::vms_server_plugins::analytics::test::UtilityProvider::getHomeDir | ( |  | ) | const
| inline override virtual

Called by homeDir()

Implements nx::sdk::IUtilityProvider0.

## ◆ getServerSdkVersion()

virtual const nx::sdk::IString* nx::vms_server_plugins::analytics::test::UtilityProvider::getServerSdkVersion | ( |  | ) | const
| inline override virtual

Called by serverSdkVersion()

Implements nx::sdk::IUtilityProvider1.

## ◆ setServiceUsageQuantities()

virtual void nx::vms_server_plugins::analytics::test::UtilityProvider::setServiceUsageQuantities | ( | const char * | engineId,
|  | const nx::sdk::IStringMap * | values
| ) |  |
| inline override virtual

Sets a map of service ids to their usage quantities.

Parameters

  engineId | Engine id that is assigned to an engine using IEngineInfo.
  values | String map of key-values where key is a service uuid serialized as string and value is a service usage qunatity count serialized as string.

Implements nx::sdk::IUtilityProvider.

## ◆ subscribeForCloudTokenUpdate()

virtual void nx::vms_server_plugins::analytics::test::UtilityProvider::subscribeForCloudTokenUpdate | ( | ICloudTokenSubscriber * | subscriber | ) |
| inline override virtual

Each subscriber will be notified. Make sure not to subscribe multiple times per plugin.

Implements nx::sdk::IUtilityProvider5.

## ◆ supportedVectorizationModels()

virtual IString* nx::vms_server_plugins::analytics::test::UtilityProvider::supportedVectorizationModels | ( |  | ) | const
| inline override virtual

Comma-separated list of supported image/text vectorization model names. Example: "openai/clip-vit-large-patch14-336". The plugin can specify a vectorization model from this list in the EngineManifest, and use it to generate and attach a vector to the track's best shot data.

Implements nx::sdk::IUtilityProvider6.

## ◆ vmsSystemTimeSinceEpochMs()

virtual int64_t nx::vms_server_plugins::analytics::test::UtilityProvider::vmsSystemTimeSinceEpochMs | ( |  | ) | const
| inline override virtual

VMT #4.

Returns
  Synchronized System time - common time for all Servers in the VMS System.

Implements nx::sdk::IUtilityProvider0.

The documentation for this class was generated from the following file:

- samples/analytics/unit_tests/src/analytics_plugin_ut.cpp